//
//  MyRobotsTestViewController.m
//  MyRobotsAPITest
//
// Written by John Keogh of Upsoni, LLC for demo purposes and released
// into the public domain.  No warrantee or guarantee of any type is
// associated with this code.  Use at you own risk.
//

#import "MyRobotsTestViewController.h"


@interface MyRobotsTestViewController ()

@end


@implementation MyRobotsTestViewController

@synthesize retrievedValueLabel, valueToSendTextField;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}


-(IBAction)sendValue:(id)sender
{
    NSString *valueToSend = [self encodeString:[self.valueToSendTextField text]];
    
    NSString *updateURL = [NSString stringWithFormat:kRobotUpdateURLFormat, kAPIKey, valueToSend];
    //not doing anything with this, but can check if for errors
    NSString *agentString = @"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_6; en-us) AppleWebKit/525.27.1 (KHTML, like Gecko) Version/3.2.1 Safari/525.27.1";
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:
                                    [NSURL URLWithString:updateURL]];
    [request setValue:agentString forHTTPHeaderField:@"User-Agent"];
    NSError *error;
    [ NSURLConnection sendSynchronousRequest:request returningResponse: nil error: &error];
}

-(IBAction)retrieveValue:(id)sender
{
    NSString *retrievalURL = [NSString stringWithFormat:kRobotRetrieveURLFormat, kRobotId, kAPIKey];
    NSDictionary *retrievedData = [self parseJSONFileAtURL:retrievalURL];
    if(retrievedData!=nil){
        //dump all keys and values to see what was returned
        for (id key in retrievedData) {
            NSLog(@"key: %@, value: %@", key, [retrievedData objectForKey:key]);
        }
        if([retrievedData valueForKey:@"feeds"]!=nil){
            //just get the last item in the feeds, it is the latest
            if([((NSArray *)[retrievedData valueForKey:@"feeds"]) count]>0)
            {
                NSDictionary *latestFeedItem = [((NSArray *)[retrievedData valueForKey:@"feeds"]) lastObject];
                
                if(latestFeedItem!=nil){
                   if([latestFeedItem valueForKey:@"field1"]!=nil){
                       [self.retrievedValueLabel setText:[latestFeedItem valueForKey:@"field1"]];
                   }
                }
            }

        }
        
    }
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (NSDictionary *)parseJSONFileAtURL:(NSString *)URL
{
    
    NSString *agentString = @"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_6; en-us) AppleWebKit/525.27.1 (KHTML, like Gecko) Version/3.2.1 Safari/525.27.1";
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:
                                    [NSURL URLWithString:URL]];
    [request setValue:agentString forHTTPHeaderField:@"User-Agent"];
    NSError *error;
    NSData *jsonData = [ NSURLConnection sendSynchronousRequest:request returningResponse: nil error: &error];
    
    if(error){
        NSLog(@"error getting feed %@", error);
        return nil;
    }
    
    
    //partly taken from http://stackoverflow.com/questions/5547311/how-do-i-parse-json-with-objective-c
    
    id object = [NSJSONSerialization
                 JSONObjectWithData:jsonData
                 options:0
                 error:&error];
    
    if(error) {
        NSLog(@"%@", error);
        return nil;
    }
    
    //returns an NSDictionary, which contains an array of arrays
    //see dump above in [self retrieveValue]
    //this is hackery, but good enough for an API test
    return (NSDictionary *)object;
}


//from http://stackoverflow.com/questions/8086584/objective-c-url-encoding
-(NSString *)encodeString:(NSString *)rawString{
    NSString *escapedString = (NSString *)CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(
                                                                                                    NULL,
                                                                                                    (__bridge CFStringRef) rawString,
                                                                                                    NULL,
                                                                                                    (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                                                                    kCFStringEncodingUTF8));
    return escapedString;
    
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return NO;
}


@end
